--LED block-cipher, AddConstant function


LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ENTITY addconstant_led IS
  PORT (
    state_in  : IN STD_LOGIC_VECTOR(63 DOWNTO 0);
    rc        : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
    state_out : OUT STD_LOGIC_VECTOR(63 DOWNTO 0)   
    );
END ENTITY addconstant_led;

ARCHITECTURE rtl OF addconstant_led IS

  CONSTANT ks : STD_LOGIC_VECTOR(7 DOWNTO 0) := x"80"; --128
  
  SIGNAL int : STD_LOGIC_VECTOR(63 DOWNTO 0);
  SIGNAL int1 : STD_LOGIC_VECTOR(3 DOWNTO 0);
  SIGNAL int2 : STD_LOGIC_VECTOR(3 DOWNTO 0);
  SIGNAL int3 : STD_LOGIC_VECTOR(3 DOWNTO 0);
  SIGNAL int4 : STD_LOGIC_VECTOR(3 DOWNTO 0);
  SIGNAL int5 : STD_LOGIC_VECTOR(3 DOWNTO 0);
  SIGNAL int6 : STD_LOGIC_VECTOR(3 DOWNTO 0);
  SIGNAL int7 : STD_LOGIC_VECTOR(3 DOWNTO 0);
  
BEGIN

	int1(2 DOWNTO 0) <= STD_LOGIC_VECTOR(UNSIGNED(rc(5 DOWNTO 3)));
	int1(3) <= '0';
	int2(2 DOWNTO 0) <= STD_LOGIC_VECTOR(UNSIGNED(rc(2 DOWNTO 0)));
	int2(3) <= '0';
	int3(2 DOWNTO 0) <= STD_LOGIC_VECTOR(UNSIGNED(rc(5 DOWNTO 3)));
	int3(3) <= '0';
	int4(2 DOWNTO 0) <= STD_LOGIC_VECTOR(UNSIGNED(rc(2 DOWNTO 0)));
	int4(3) <= '0';

  int(3 DOWNTO 0)   <= x"0" XOR ks(7 DOWNTO 4);
  int(19 DOWNTO 16) <= x"1" XOR ks(7 DOWNTO 4);
  int(35 DOWNTO 32) <= x"2" XOR ks(3 DOWNTO 0);
  int(51 DOWNTO 48) <= x"3" XOR ks(3 DOWNTO 0);
  int(7 DOWNTO 4)   <= int1;
  int(23 DOWNTO 20) <= int2;
  int(39 DOWNTO 36) <= int3;
  int(55 DOWNTO 52) <= int4;
  int(15 DOWNTO 8)  <= x"00";
  int(31 DOWNTO 24) <= x"00";
  int(47 DOWNTO 40) <= x"00";
  int(63 DOWNTO 56) <= x"00";

  state_out <= state_in XOR int;

END rtl;
