--LED block-cipher, generate constant (rc)


LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY generate_constant_led IS
  PORT (
    rc_in  : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
    mode_i : IN STD_LOGIC;
    rc_out : OUT STD_LOGIC_VECTOR(5 DOWNTO 0)
    );
END ENTITY generate_constant_led;

ARCHITECTURE rtl OF generate_constant_led IS

  SIGNAL rc_enc : STD_LOGIC_VECTOR(5 DOWNTO 0);
  SIGNAL rc_dec : STD_LOGIC_VECTOR(5 DOWNTO 0);
  
BEGIN

  --encryption

  rc_enc(5 DOWNTO 1) <= rc_in(4 DOWNTO 0);
  rc_enc(0)          <= rc_in(5) XOR rc_in(4) XOR '1';

  --decryption

  rc_dec(4 DOWNTO 0) <= rc_in(5 DOWNTO 1);
  rc_dec(5)          <= rc_in(0) XOR rc_in(5) XOR '1';
  
  WITH mode_i SELECT
  rc_out <= rc_enc WHEN '0',
  rc_dec WHEN OTHERS;

  
END ARCHITECTURE rtl;
