----------------------------------------------------------------------------------
-- Company: Univ Lyon, UJM-Saint-Etienne, CNRS, Laboratoire Hubert Curien UMR 5516, F-42023, SAINT-ETIENNE, France
-- Creator: Cédric Marchand 
-- 
-- Create Date:    09:13:58 11/13/2015 
-- Design Name: 
-- Module Name:    mixcol_d - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity mixcol_d is
  port(
    state_i : in std_logic_vector(63 downto 0);
    state_o : out std_logic_vector(63 downto 0)
  );
end mixcol_d;

architecture Behavioral of mixcol_d is

  COMPONENT mixrow_d
	PORT(
		state_i : IN std_logic_vector(63 downto 0);          
		state_o : OUT std_logic_vector(63 downto 0)
		);
	END COMPONENT;

  signal row_1 : std_logic_vector(63 downto 0);
  signal row_2 : std_logic_vector(63 downto 0);
  signal row_3 : std_logic_vector(63 downto 0);

begin
  
  Inst_mixrow_d1: mixrow_d PORT MAP(
		state_i => state_i,
		state_o => row_1
	);
  
  Inst_mixrow_d2: mixrow_d PORT MAP(
		state_i => row_1,
		state_o => row_2
	);
  
  Inst_mixrow_d3: mixrow_d PORT MAP(
		state_i => row_2,
		state_o => row_3
	);
  
  Inst_mixrow_d4: mixrow_d PORT MAP(
		state_i => row_3,
		state_o => state_o
	);


end Behavioral;

